<script>
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  import {scaleLinear} from 'd3-scale';
  import {scaleBand} from 'd3-scale';
  import {axisBottom} from 'd3-axis';
  import {axisLeft} from 'd3-axis';
  import {select} from 'd3-selection';

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];
  const classservice=data.map(d=>d.service)
  const scaleValues_x=scaleBand()
  .range([0,innerWidth])
  .domain(classservice);
  const scaleValues_y=scaleLinear()
  .domain([0,3])
  .range([innerHeight,0]);
  let g;
  $:{
    let yaxis=axisLeft(scaleValues_y);
    select(g).call(yaxis);
  }
  let g2;
  $:{
    let xaxis=axisBottom(scaleValues_x);
    select(g2).call(xaxis);
  }
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <text  x=0 y=0 transform=" translate(25,175) rotate(270)" fill="currentColor" style="font-size:0.75em;">Viewers (Million) </text>
  <g transform={`translate(${margin.left},${margin.top})`}>
    <!--  -->
    {#each data as value}
    <rect x={scaleValues_x(value.service)+10} y={scaleValues_y(+value.viewers)} width="75" height={innerHeight-scaleValues_y(+value.viewers)} fill="steelblue"/>
    {/each}
  </g>
  <g transform="translate({margin.left},{margin.top})" bind:this={g}>
  </g>
  <g transform="translate({margin.left},{innerHeight+margin.top})" bind:this={g2}>
  </g>
</svg>
